//
// SSDT-UIAC.dsl
//
// Dell Alienware 13 R3 
//
// This SSDT contains customizations for USBInjectAll.kext.
//
//

DefinitionBlock ("", "SSDT", 2, "hack", "UIAC", 0)
{
    Device(UIAC)
    {
        Name(_HID, "UIA00000")

        Name(RMCF, Package()
        {
            "8086_a12f", Package()
            {
                "port-count", Buffer() { 0x1A, 0, 0, 0 }, //Max virtual port is 26 (0x1A)
                "ports", Package()
                {
                    "HS01", Package() //Left side USB Type A (2.0)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x01, 0, 0, 0 },
                    },
                    
                    "HS02", Package() //Right side USB Type A (2.0)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x02, 0, 0, 0 },
                    },
                    
                    /***                    
                    "HS03", Package() // Empty
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x03, 0, 0, 0 },
                    },
                    ***/
                    
                    "HS04", Package() //AlienwareFX Interface (AW13)
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x04, 0, 0, 0 },
                    },
                    
                    "HS05", Package() //Bluetooth (BCM20702A0)
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x05, 0, 0, 0 },
                    },
                    
                    /***                                        
                    "HS06", Package() // Empty
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x06, 0, 0, 0 },
                    },
                    ***/
                    
                    "HS07", Package() // Camera (Integrated Webcam HD)
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x07, 0, 0, 0 },
                    },
                                        
                    "HS08", Package() // Right side USB Type C (USB 2)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x08, 0, 0, 0 },
                    },
                    
                    /*** 
                    "HS09", Package() // Empty
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x09, 0, 0, 0 },
                    },
                    
                    "HS12", Package() // Empty
                    {
                        "UsbConnector", 0xFF,
                        "port", Buffer() { 0x0C, 0, 0, 0 },
                    },
                    ***/

                    "SS01", Package() //Left side USB Type A (3.0)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x11, 0, 0, 0 },
                    },
                    
                    /***
                    "SS02", Package() // Empty
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x12, 0, 0, 0 },
                    },
                                        
                    "SS03", Package() // Empty
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x13, 0, 0, 0 },
                    },
                    ***/
                    
                    "SS04", Package() //Right side USB Type A (3.0)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x14, 0, 0, 0 },
                    },
                    
                    "SS05", Package() //Right side USB Type C (3.0)
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 0x15, 0, 0, 0 },
                    },
                }
            }
        })
    }
}
//EOF
